﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Services;
using System.Web.Script.Services;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    [WebMethod]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json, UseHttpGet=true)]
    public static DataResult GetGridData()
    {
        var queryString = HttpContext.Current.Request.QueryString;

        //Get the current page index and page size from the QueryString
        int skip = Convert.ToInt32(HttpContext.Current.Request.QueryString["$skip"]);
        int take = Convert.ToInt32(HttpContext.Current.Request.QueryString["$top"]);

        //Get the sorted column and direction
        string orderBy = HttpContext.Current.Request.QueryString["$orderBy"];


        //get the data source. For this example the data is dynamically generated and then manual paging and sorting is applied
        // In your case you can instead build a query to the database and just return the result.
        DataResult data = new DataResult();
        List<Item> items = new List<Item>();

                for (int i = 0; i < 20; i++)
        {
            items.Add(new Item() { ID=i, Name="Name"+i });
        }

                data.Items = items;

                //manual sorting
                if (orderBy != null)
                {
                    string colKey = orderBy.Split(' ')[0];
                    string direction = orderBy.Split(' ')[1];
                    if (colKey == "ID")
                    {
                        if (direction == "asc")
                        {
                            data.Items = data.Items.OrderBy(x => x.ID).ToList();
                        }
                        else
                        {
                            data.Items = data.Items.OrderByDescending(x => x.ID).ToList();
                        }
                    }
                    else
                    {
                        if (direction == "asc")
                        {
                            data.Items = data.Items.OrderBy(x => x.Name).ToList();
                        }
                        else
                        {
                            data.Items = data.Items.OrderByDescending(x => x.Name).ToList();
                        }
                    }

                }



        //manual paging    
        data.Items = data.Items.Skip(skip).Take(take).ToList();
       
     
        //this is for paging. The total record count needs to be returnedas part of the response object.
        data.TotalRecordsCount = items.Count;


        //return the result
        return data;

    }
}